/* crash-pipe: handle core file passed from stdin
 *
 * Copyright (c) 2016 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Author: Łukasz Stelmach <l.stelmach@samsung.com>
 */

#if defined(__x86_64__) || defined(__aarch64__)
#define elf_ehdr Elf64_Ehdr
#define elf_phdr Elf64_Phdr
#define elf_nhdr Elf64_Nhdr
#define elf_addr_t Elf64_Addr
#define _ELFCLASS ELFCLASS64
#elif defined(__i386__) || defined(__arm__)
#define elf_ehdr Elf32_Ehdr
#define elf_phdr Elf32_Phdr
#define elf_nhdr Elf32_Nhdr
#define elf_addr_t Elf32_Addr
#define _ELFCLASS ELFCLASS32
#else
#error "Unsupported architecture"
#endif

unsigned long arch_get_bp(elf_gregset_t*);
unsigned long arch_get_ip(elf_gregset_t*);
unsigned long arch_get_sp(elf_gregset_t*);
void arch_dump_registers(elf_gregset_t*);
